/* 
 *  @Ming-Ching Tiew@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1997 Ming-Ching Tiew.
 *  ALL RIGHTS RESERVED. 
*/ 
/* 
 * HISTORY
 * $Log: fencryptor.c,v $
 * Revision 0.8  1/23/1997
 * 	First version.
 * Revision 0.9  2/8/1997
 * 	Second version.
 *
 * $EndLog$
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$RCSfile: fencryptor.c,v $ $Revision: 0.9 $ $Date: 2/8/1997 $"
#endif
#endif
/*
*  (c) Copyright 1997, Ming-Ching Tiew */

#include <sys/stat.h>
#include <Xm/XmAll.h>       /* Motif Toolkit */
#include <Mrm/MrmPublic.h>  /* Mrm Toolkit */
#include "capi.h"

/* Although it's really bad to hardcode Positions, keep this for
   now for compatibility */
#define NEW_BUTTON_X 11

static Widget top_level;
static int Choice = 1;  /* encrypt by default */
static int KeyType = 0; /* conventional by default */
static int Algo = CRYPT_USE_DEFAULT;    /* 3DES by default*/
static int Mode = CRYPT_USE_DEFAULT; 
static int ModeStream = CRYPT_MODE_STREAM;
static int ModeBlock = CRYPT_USE_DEFAULT;
extern int Perform_Task(String, String, String, int, int, int);
static String passphrase;

static void 
#ifdef _NO_PROTO
About_CB(widget, tag, data )
	Widget	widget;
	XtPointer tag;
	XtPointer data;
#else
About_CB(
        Widget	widget,
	XtPointer tag,
	XtPointer data)
#endif /* _NO_PROTO */
{
    static XmString message;
    Widget mbox = NULL;
    mbox = XtNameToWidget( top_level, "*infoDialog" );
    message = XmStringGenerate( "Fencryptor version 0.9.\n"
         "Copyright Ming-Ching Tiew.", NULL, XmCHARSET_TEXT, NULL);
 /*
    message = XmStringCreateSimple("Fencryption version 0.9.\r\n"
           "Written by Tiew Ming Ching");
  */
    XtVaSetValues( mbox, XmNmessageString, message, NULL, NULL );  
    XtManageChild( mbox );
}

static void 
#ifdef _NO_PROTO
KeyType_CB(widget, tag, data )
	Widget	widget;
	int* tag;
	XtPointer data;
#else
KeyType_CB(
        Widget	widget,
	int* tag,
	XtPointer data)
#endif /* _NO_PROTO */

{
   KeyType = *tag;
   if( KeyType == 0 ) {
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_signlabel") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_signature") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_browsesign") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_encryptlabel") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_recipient") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_browsercpt") );

   }
   else {
    XtManageChild( XtNameToWidget( top_level, "*fencryptor_signlabel") );
    XtManageChild( XtNameToWidget( top_level, "*fencryptor_signature") );
    XtManageChild( XtNameToWidget( top_level, "*fencryptor_browsesign") );
    XtManageChild( XtNameToWidget( top_level, "*fencryptor_encryptlabel") );
    XtManageChild( XtNameToWidget( top_level, "*fencryptor_recipient") );
    XtManageChild( XtNameToWidget( top_level, "*fencryptor_browsercpt") );
  }   
}

static void 
#ifdef _NO_PROTO
FileEncryptor_CB(widget, tag, data )
	Widget	widget;
	XtPointer tag;
	XtPointer data;
#else
FileEncryptor_CB(
        Widget	widget,
	XtPointer tag,
	XtPointer data)
#endif /* _NO_PROTO */

{
    XtManageChild( XtNameToWidget( top_level, "*fencryptor_key") );
    XtManageChild( XtNameToWidget( top_level, "*fencryptor_algo") );
    if( Algo == CRYPT_ALGO_RC4 ) 
       XtManageChild( XtNameToWidget( top_level, "*fencryptor_modeStream") );
    else
       XtManageChild( XtNameToWidget( top_level, "*fencryptor_mode") );
    Choice = 1;
    if( KeyType == 1 ) {
       XtManageChild( XtNameToWidget( top_level, "*fencryptor_signlabel") );
       XtManageChild( XtNameToWidget( top_level, "*fencryptor_signature") );
       XtManageChild( XtNameToWidget( top_level, "*fencryptor_browsesign") );
       XtManageChild( XtNameToWidget( top_level, "*fencryptor_encryptlabel") );
       XtManageChild( XtNameToWidget( top_level, "*fencryptor_recipient") );
       XtManageChild( XtNameToWidget( top_level, "*fencryptor_browsercpt") );
   }
}

 
static void 
#ifdef _NO_PROTO
FileDecryptor_CB(widget, tag, data )
	Widget	widget;
	XtPointer tag;
        XtPointer data;
#else
FileDecryptor_CB(
        Widget	widget,
	XtPointer tag,
	XtPointer data)
#endif /* _NO_PROTO */

{
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_key") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_algo") );
      XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_mode") );
      XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_modeStream") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_signlabel") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_signature") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_browsesign") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_encryptlabel") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_recipient") );
    XtUnmanageChild( XtNameToWidget( top_level, "*fencryptor_browsercpt") );
    Choice = 2;

}

static void 
#ifdef _NO_PROTO
Quit_CB(widget, tag, data )
	Widget	widget;
        XtPointer tag;
	XtPointer data;
#else
Quit_CB(
        Widget	widget,
	XtPointer tag,
	XtPointer data)
#endif /* _NO_PROTO */

{
    cryptEnd();
    exit();
}

static void 
#ifdef _NO_PROTO
InputBrowse_CB(widget, tag, data )
	Widget	widget;
        String tag;
	char* data;
#else
InputBrowse_CB(
        Widget	widget,
	String tag,
	char* data)
#endif /* _NO_PROTO */

{
    XtManageChild( XtNameToWidget( top_level, tag) );
}

static void 
#ifdef _NO_PROTO
FileSelected_CB(widget, tag, data )
	Widget	widget;
        String tag;
	XtPointer data;
#else
FileSelected_CB(
        Widget	widget,
	String tag,
	XtPointer data)
#endif /* _NO_PROTO */

{
    Widget textfield = NULL, text;
    char* filename;
    textfield = XtNameToWidget( top_level, tag);
    text = XmFileSelectionBoxGetChild(widget, XmDIALOG_TEXT);
    filename = XmTextGetString(text);
    XtVaSetValues( textfield, XmNvalue, filename, NULL, NULL );  

}

static void 
#ifdef _NO_PROTO
Go_CB(widget, tag, data )
	Widget	widget;
        int* overwrite;
	XtPointer data;
#else
Go_CB( 
        Widget	widget,
	int* overwrite,
	XtPointer data)
#endif /* _NO_PROTO */

{
       
    Widget tmp = NULL, mbox = NULL;
    struct stat st;
    static XmString message;
    static String inputfilename;
    static String outputfilename;
    int i;
    static char buf[100];
 
    /* Get the messageBox widget */
    mbox = XtNameToWidget( top_level, "*infoDialog" );

    /* Get input filename */
    tmp = XtNameToWidget( top_level, "*fencryptor_inputfile");
    XtVaGetValues( tmp, XmNvalue, &inputfilename, NULL, NULL );  

    if( *inputfilename == '\0' ) {
       message = XmStringCreateSimple("Input filename is null !!!");
       XtVaSetValues( mbox, XmNmessageString, message, NULL, NULL );  
       XtManageChild( mbox );
       XmStringFree(message);
       return;
    }
 
    if( stat(inputfilename, &st) == -1 ) {
       message = XmStringCreateSimple("Input file does not exist!!!");
       XtVaSetValues( mbox, XmNmessageString, message, NULL, NULL );  
       XtManageChild( mbox );
       XmStringFree(message);
       return;
    }

    /* Get output filename */
    tmp = XtNameToWidget( top_level, "*fencryptor_outputfile");
    XtVaGetValues( tmp, XmNvalue, &outputfilename, NULL, NULL );  
    if( *outputfilename == '\0' ) {
       message = XmStringCreateSimple("Output filename is null !!!");
       XtVaSetValues( mbox, XmNmessageString, message, NULL, NULL );  
       XtManageChild( mbox );
       XmStringFree(message);
       return;
    }
 
    if( stat(outputfilename, &st) != -1 ) {
       if( *overwrite == 0 ) {
          tmp = XtNameToWidget( top_level, "*questionDialog" );
          XtManageChild( tmp );
          return;
       }
       else if ( *overwrite == 2 ) 
          return;
    } 

    /* Get passphrase */
    tmp = XtNameToWidget( top_level, "*fencryptor_passphrase");
    XtVaGetValues( tmp, XmNvalue, &passphrase, NULL, NULL );  
    if( *passphrase == '\0' ) {
       message = XmStringCreateSimple("No passphrase !!!");
       XtVaSetValues( mbox, XmNmessageString, message, NULL, NULL );  
       XtManageChild( mbox );
       XmStringFree(message);
       return;
    }

    /* Go perform job */
    i = Perform_Task(inputfilename, outputfilename, passphrase, Choice, Algo, Mode);    
    
    /* Reset passphrase */
    *passphrase = '\0';
    XtVaSetValues( tmp, XmNvalue, passphrase, NULL, NULL );  

    if( i != 0 ) {
       if( i == -152 )
         sprintf(buf, "Bad passphrase or data, Error code %d", i);
       else
         sprintf(buf, "Error code %d", i);
       message = XmStringCreateSimple(buf);
    }
    else if( Choice == 1 )  
       message = XmStringCreateSimple( "Encryption is successful.");
    else if( Choice == 2 )
       message = XmStringCreateSimple( "Decryption is successful.");

    XtVaSetValues( mbox, XmNmessageString, message, NULL, NULL );  
    XtManageChild( mbox );
    XmStringFree(message);
}

static void 
#ifdef _NO_PROTO
FileEncrypt_Algo(widget, tag, data )
	Widget	widget;
        int* tag;
	XtPointer data;
#else
FileEncrypt_Algo( 
        Widget	widget,
	int* tag,
	XtPointer data)
#endif /* _NO_PROTO */

{
     Widget tmp = NULL;
     Widget tmp2 = NULL;
     static XmString str;
     Algo = *tag;

     switch(Algo) {
     case CRYPT_ALGO_RC4:
        
           XtUnmanageChild(XtNameToWidget( top_level, "*fencryptor_mode" ) );
           XtManageChild( XtNameToWidget( top_level, "*fencryptor_modeStream"));
           Mode = ModeStream;
           break;

     case CRYPT_USE_DEFAULT: 
     case CRYPT_ALGO_DES: 
     case CRYPT_ALGO_3DES: 
     case CRYPT_ALGO_IDEA: 
     case CRYPT_ALGO_MDCSHS: 
     case CRYPT_ALGO_RC2: 
     case CRYPT_ALGO_RC5: 
     case CRYPT_ALGO_SAFER: 
     case CRYPT_ALGO_BLOWFISH: 
     case CRYPT_ALGO_GOST: 
     case CRYPT_ALGO_SKIPJACK: 
           XtUnmanageChild(XtNameToWidget( top_level, "*fencryptor_modeStream" ) );
           XtManageChild( XtNameToWidget( top_level, "*fencryptor_mode"));
           Mode = ModeBlock;
     }

}

static void 
#ifdef _NO_PROTO
FileEncrypt_Mode(widget, tag, data )
	Widget	widget;
        int* tag;
	XtPointer data;
#else
FileEncrypt_Mode( 
        Widget	widget,
	int* tag,
	XtPointer data)
#endif /* _NO_PROTO */

{
     Mode = *tag;
     if( Algo == CRYPT_ALGO_RC4 )
       ModeStream = Mode;
     else
       ModeBlock = Mode;
}

static void 
#ifdef _NO_PROTO
ModifyVerify_CB(widget, tag, data )
	Widget	widget;
        XtPointer tag;
	XtPointer data;
#else
ModifyVerify_CB( 
        Widget	widget,
	XtPointer tag,
	XtPointer data)
#endif /* _NO_PROTO */

{
   /* OK, not working.
      I must admit that I don't know how to do this.
      But anyway, long passphrase should be echoed in the textfield.
      Can you type say 200 character passphrase without any typo error ?
    */
   /*
     int i, len;
     char* echo;
     static String str; 
     XmTextVerifyCallbackStruct* info = (XmTextVerifyCallbackStruct* )data;
     XtVaGetValues( widget, XmNvalue, &str, NULL, NULL );  

     echo = (char*)malloc(200);
     len = info->text->length;
     if( len > 0 ) {
       memset( echo, '*', info->text->length );
       echo[len] = '\0';
       strcpy (passphrase + strlen(str), info->text->ptr);
       info->text->ptr = echo;
     }
     else
      *passphrase = '\0';
     printf("passphrase = %s\n", passphrase);
   */
     
}

static String uid_vec[]={"fencryptor.uid"}; /* MRM database file list   */

static MrmRegisterArg	reg_vec[] = {       /* Callback bindings */
    {"FileEncryptor_CB", (XtPointer)FileEncryptor_CB},
    {"FileDecryptor_CB", (XtPointer)FileDecryptor_CB},
    {"InputBrowse_CB",   (XtPointer)InputBrowse_CB},
    {"FileSelected_CB",  (XtPointer)FileSelected_CB},
    {"Go_CB",            (XtPointer)Go_CB},
    {"Quit_CB",          (XtPointer)Quit_CB},
    {"ModifyVerify_CB",  (XtPointer)ModifyVerify_CB},
    {"FileEncrypt_Algo", (XtPointer)FileEncrypt_Algo},
    {"FileEncrypt_Mode", (XtPointer)FileEncrypt_Mode},
    {"KeyType_CB",       (XtPointer)KeyType_CB},
    {"About_CB",         (XtPointer)About_CB}
};


/*
 *  Main program: fetch the fencryptor.uil description.
 */
#ifdef _NO_PROTO
int main(argc, argv) int argc; char *argv[];
#else
int main(int argc, char *argv[])
#endif /*_NO_PROTO */
{
    XtAppContext        app_context;
    Widget              fencryptor_main;
    MrmCode		mrm_class ;
    MrmHierarchy	mrm_hierarchy;		

    /*  
        Initialize cryptlib
     */
   int status;

   status = cryptInit();
   if( cryptStatusError( status ) ) {
	printf( "cryptInit() failed with error code %d.\n", status );
        exit(status);
   }
   status = cryptAddRandom( NULL, CRYPT_RANDOM_SLOWPOLL );
   if( cryptStatusError( status ) ) {
	printf( "cryptAddRandom failed with error code %d.\n", status );
        exit(status);
   }
   
    /*
     *  Initialize the MRM
     */

    MrmInitialize ();

    /* 
     * Initialize Xt and create a resizable shell 
     */

    top_level = XtVaAppInitialize(&app_context, "XmdHelloMotif", 
				  NULL, 0, &argc, argv, NULL, 
				  XmNallowShellResize, True, NULL); 

    /*
     *  Create the Mrm hierarchy
     */

    if (MrmOpenHierarchy (XtNumber(uid_vec),	    /* number of files	    */
			  uid_vec, 		    /* files     	    */
			  NULL,			    /* os_ext_list (null)   */
			  &mrm_hierarchy)	    /* ptr to returned id   */
	!= MrmSUCCESS) {
	XtError ("can't open hierarchy\n");
    }

    /*
     * 	Register our callback routines so that the resource manager can 
     * 	resolve them at widget-creation time.
     */

    if (MrmRegisterNames (reg_vec, XtNumber(reg_vec)) != MrmSUCCESS)
	XtError("can't register names\n");

    /*
     *  Call MRM to fetch and create the widgets 
     */

    if (MrmFetchWidget (mrm_hierarchy,
			"fencryptor_main",
			top_level,
			&fencryptor_main,
			&mrm_class)
	!= MrmSUCCESS)
	XtError ("can't fetch interface\n");

    /*
     *  Make the toplevel widget "manage" the main window (or whatever the
     *  the uil defines as the topmost widget).  This will
     *  cause it to be "realized" when the toplevel widget is "realized"
     */

    XtManageChild(fencryptor_main);
    
    /*
     *  Realize the toplevel widget.  This will cause the entire "managed"
     *  widget hierarchy to be displayed
     */

    XtRealizeWidget(top_level);

    /*
     *  Loop and process events
     */

    XtAppMainLoop(app_context);

    /* UNREACHABLE */
    return (0);
}

